<p>title: Argumen Referensi pada Fungsi
description:</p>
<hr />
<p>Ketika kita melewatkan variabel ke dalam argumen sebuah fungsi, nilai yang ada di dalam variabel tersebut tidak akan berubah.</p>
<pre><code>function kuadrat($angka){
    $angka *= $angka;
    echo $angka;
}

$x = 5;
echo $x;
kuadrat($x);
echo $x;</code></pre>
<p>Pada kode di atas, nilai awal <code>$x</code> adalah 5. Saat fungsi <code>kuadrat($x)</code> dipanggil, fungsi tersebut akan mengkuadratkan nilai variabel argumen dan mencetaknya. Adapun variabel <code>$x</code> setelah proses pemanggilan fungsi <code>kuadrat()</code> tetap bernilai 5.</p>
<p>Dalam beberapa kasus kita perlu menerima perubahan pada variabel saat variabel tersebut dilewatkan ke dalam sebuah fungsi. Hal ini dikenal dengan istilah <em>pass by reference</em>, artinya kita tidak melewatkan nilai ke dalam argumen, tapi melewatkan referensi variabel.</p>
<p>Dengan demikian ketika nilai argumen tersebut berubah selama proses di dalam fungsi, variabel referensinya pun ikut berubah, cara membuat argumen referensi adalah dengan menambahkan karakter <code>&amp;</code> sebelum variabel argumen pada deklarasi fungsi.</p>
<pre><code>function kuadrat(&amp;$angka){
    $angka *= $angka;
}

$x = 5;
echo $x;
kuadrat($x);
echo $x;</code></pre>
<p>Pada contoh kode di atas, kita menulis argumen <code>&amp;$angka</code> dengan menyertakan karakter <code>&amp;</code> sebelum variabel argumen. Variabel <code>$x</code> awalnya bernilai 5. Saat fungsi <code>kuadrat($x)</code>dipanggil, nilai variabel <code>$x</code> pun ikut dikuadratkan. Sehingga setelah pemanggilan fungsi, nilai variabel <code>$x</code> akan bernilai 25.</p>
<h2>Praktek</h2>
<ul>
<li>Jalankan kode yang ada di editor. Apakah nilai variabel <code>$x</code> sebelum dan sesudah pemanggilan fungsi <code>kuadrat()</code> berubah? Mengapa?</li>
<li>Tambahkan karakter <code>&amp;</code> sebelum variabel argumen <code>$angka</code> pada deklarasi fungsi. Lalu jalankan kembali program. Apakah sekarang nilai <code>$x</code> sebelum dan sesudah pemanggilan fungsi berubah? Mengapa demikian?</li>
<li>Apa yang terjadi bila Kamu memanggil fungsi <code>kuadrat()</code> dengan melewatkan nilai langsung pada argumennya, misalnya <code>kuadrat(5);</code> ?</li>
</ul>
<iframe width="100%" height="400" frameborder="0" src="https://development.codepolitan.com/coding/editor/fungsi-argumentreferensipadafungsi"></iframe>
<p>Bila Kamu sudah mencoba skenario program dan sudah paham dengan materi yang disampaikan, klik tombol &quot;Next Lesson&quot; di bawah editor.</p>